/*---------------------------------------------------------------
!	Dieses Programm mu in den Start-Ordner.
!	Es legt die Log-Buch-Datei an und wertet
!	den Timestamp der Datei aus.
!	Ist der Timestamp der Datei lter, als der
!	letzte STOP-Eintrag, dann ist der Rechner abgestrzt
+--------------------------------------------------------------*/

#include <tos.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include <aes.h>

typedef struct {
	DOSTIME dt;
	char status;		/* 'S' = Start; 'E' = Ende; 'A' = Absturz	*/
	char bs;			/* wird vom Start nur bernommen!	*/
} LOG;

void main(void)

{
	char proto_file[128], *c[];
	int fd;
	long l;
	LOG lg;
	
	Pdomain(1);	/* Lange Dateinamen verarbeiten	*/
	shel_envrn(c, "SEEBAER-FILE=");
	
	if (*c != NULL) strcpy(proto_file, *c);
	else strcpy(proto_file, "C:\\SEEBAER.LOG");
	
	l = Fopen(proto_file, FO_RW);	/* Daten anhngen!	*/
	if (l > 0) {					/* Wenn datei nicht existiert, dann nichts machen!	*/
		fd = (int )l;
		Fseek(sizeof(LOG) * -1, fd, 2);	/* auf den letzten Datensatz positionieren	*/
		l = Fread(fd, sizeof(LOG), &lg);

		if (lg.status != 'E') {			/* Nur, wenn Endekennung fehlt, weil vielleicht LOGSTART nicht mehr luft!	*/
			lg.status='E';				/* Endekennung	*/
			lg.dt.date = Tgetdate();
			lg.dt.time = Tgettime();
			Fwrite(fd, sizeof(LOG), &lg);
		}
		Fclose(fd);
	}
	return;
}